const _ = require("lodash");
const ko = require("knockout");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

const template = require("./content.pug");
const packageNames = require("../packageNames");

let areUpdatesAvailable = ko.observable(false);
let updates = ko.observable();
const otherUpdates = ko.computed(() => _(updates() || {}).toPairs().filter(function (pair) {
        return pair[0] !== "capturecast";
    }).map(function (pair) {
        return pair[1];
    }).flatten().value()
);

let resolver = null;

const dialog = Dialog({
    areUpdatesAvailable: areUpdatesAvailable,
    updates: updates,
    packageNames: packageNames,
    otherUpdates: otherUpdates,

    open (updates, areUpdatesAvailable)
    {
        this.updates(updates);
        this.areUpdatesAvailable(areUpdatesAvailable);
        this.show();
        return new Promise((resolve, reject) => resolver = resolve);
    },

    submit ()
    {
        if (!areUpdatesAvailable())
        {
            return;
        }

        resolver(updates());
    }
}, { template: template });

module.exports = dialog;
